#!/usr/bin/perl

use strict;
use CGI qw/:standard *table/;
use Fcntl qw/:flock/;

sub fehler {
    my $err = "@_";
    print "\n", h1("Unerwarteter Fehler"), "\n", p($err), "\n", end_html;
}

my(
    $GBuch,   # Name der Gstebuch-Datei
    $MaxGB,   # Maximale Anzahl von Eintrgen in GB
    $GBTitel, # Titel des Gstebuchs
    $akt,     # neuer Eintrag
    @inhalt,  # Inhalt des Gstebuchs
    $eintrag  # ein Eintrag im Gstebuch
);

$GBTitel = "Gstebuch von Heinz Kredel";
$GBuch   = "/tmp/gb-kredel ";
$MaxGB   = 10;

print header;
print start_html({-bgcolor=>'white'}, $GBTitel);
print "\n", h1($GBTitel), "\n";

$akt = CGI->new();

if ($akt->param('eingabe')) {
   $akt->param("datum", scalar localtime);
   @inhalt = ($akt);
}

open(GBUCH,"+< $GBuch") || fehler("$GBuch kann nicht geffnet werden.");
flock(GBUCH, LOCK_EX) || fehler("$GBuch kann nicht exclusiv verwendet werden");
while (!eof(GBUCH) && @inhalt < $MaxGB) {
      $eintrag = CGI->new(\*GBUCH);
      push @inhalt, $eintrag;
}

seek(GBUCH, 0, 0 ) || fehler("$GBuch kann nicht zurckgesetzt werden.");
foreach $eintrag (@inhalt) {
     $eintrag->save(\*GBUCH);
}
truncate(GBUCH, tell(GBUCH));
close(GBUCH);

print "\n", hr, "\n", start_form();
print start_table();
print "<tr><td valign='top'>&nbsp;<br>Nachricht: </td>\n<td valign='top'>",
      $akt->textarea(-NAME => "eingabe",
                     -OVERRIDE => 1,
                     -ROWS => "4",
                     -COLS => "50",
                     -VALUE => "" ), 
#                     -VALUE => "Hier bitte Nachricht eingeben." ), 
#                     -VALUE => $akt->param('eingabe') ), 
      "</td></tr>\n";
print "<tr><td>Name: </td>\n<td>", 
      $akt->textfield(-NAME => "name",
                      -OVERRIDE => 1,
                      -SIZE => "50",
                      -VALUE => $akt->param('name')), 
      "</td></tr>\n";
print "<tr><td>", $akt->reset("Lschen"), "</td>\n<td>",
      $akt->submit("Eintragen"),"</td></tr>\n";
print end_table();
print "\n", end_form(), "\n", hr, "\n";

print h2("Bisherige Eintrge"), "\n";
foreach $eintrag (@inhalt) {
     print p($eintrag->param("eingabe")), "\n";
     print p({-ALIGN => "right"}, 
             $eintrag->param("name"),
             " @ ", 
             $eintrag->param("datum"), 
            ), "\n";
}
print hr, "\n", end_html, "\n";
